package trader.nw;

import trader.*;
import trader.db.*;

public class Stock3TierServer {

  public static void main(String args[]) {
    
    System.out.println("Stock3TierServer.main:  start");

    String dbHost = "localhost";
			
    try {
      if (args.length > 0) {
        dbHost = args[0];
      }		
      // create instance of model
      StockModel model = new StockModelDbImpl(dbHost);
      StockMarket stockMarket = new StockMarket(model);
		
      StockModelCommandServer stockModelCmdServer = new StockModelCommandServer(model);
      NwServer nwServer = new NwServer(7001, stockModelCmdServer);
	  
    } catch (Exception e) {
      System.out.println(e.toString());
    }
  }
}



