package trader.nw;

import trader.*;
import java.io.*;

public class StockViewNwImpl implements StockView, Serializable {
  
  private String hostname;
  private int port;
  private NwClient nwClient = null;

  /** Creates new StockViewNwImpl */
  public StockViewNwImpl(String hostname, int port) {
    System.out.println("StockViewNwImpl.constructor:  instance created");
    this.hostname = hostname;
    this.port = port;
  }

  public void handleStockChange(Stock stock) throws BrokerException {

    System.out.println("StockViewNwImpl.handleStockChange");
		
    HandleStockChangeCommand cmd = new HandleStockChangeCommand(stock);
		
    if (nwClient == null) {
      nwClient = new NwClient(hostname, port);
    }		
    try {
      nwClient.send(cmd);
    } catch (Exception e) {
      System.out.println("Exception in StockViewNwImpl.handleStockChange");
      System.out.println(e);
    }
  }
}



