package trader;

public interface StockModel {
	
  // Stock model state change listener registration methods
  
  /** -----------------------------------------------------------
   * Adds requester to the list of objects to be notified when a
   * stock model alters state
   */
  public void addChangeListener(StockView sv) throws BrokerException;
  
  // stock model state change methods
   
  /** -----------------------------------------------------------
   * changes prices for the stock
   */
  public void updateStockPrice(Stock stock) throws BrokerException;
  
  // Stock model state query methods
  
  /** -----------------------------------------------------------
   * gets Stock corresponding to the symbol
   */
  public Stock getStock(String sym) throws BrokerException;
  
  /** -----------------------------------------------------------
   * returns all stock in the enterprise data store
   */
  public Stock[] getAllStocks() throws BrokerException;

}
