package trader;

import trader.db.*;

public class StockModelTest {

  public static void main (String args[])  {

    System.out.println("StockModelTest.main: testing StockModelDbImpl");
		
    StockModelDbImpl db = null;
    Stock stock = null;
		
    try {
      db = new StockModelDbImpl();
    } catch (Exception e) {
      System.out.println(e);
    }
			
    try {	
      // testing retrieving all stocks
      System.out.println("StockModelTest.main: retrieving all stocks");
      Stock [] allStocks = db.getAllStocks();
      System.out.println("StockModelTest.main: printing all stocks"); 
      for (int i = 0; i < allStocks.length; i++) {	
        System.out.println(allStocks[i]);
      }
			
    } catch (Exception e) {
      System.out.println(e);
    }
			
    System.out.println();
    System.out.println();
		
    try {
      // testing getting a valid stock
      System.out.println("StockModelTest.main: retrieving valid stock BWInc");
      stock = db.getStock("BWInc");
      System.out.println("StockModelTest.main: " +  stock);
			
    } catch (Exception e) {
      System.out.println(e);
    }
		
    System.out.println();
    System.out.println();
		
    try {
      // testing getting an invalid stock
      System.out.println("StockModelTest.main: retrieving invalid stock JUNK");
      stock = db.getStock("JUNK");
      System.out.println(stock);
    } catch (Exception e) {
      System.out.println(e);
    }
		
    System.out.println();
    System.out.println();
				
    try {
			
      // testing updating a valid stock price
      System.out.println("StockModelTest.main: updating valid stock SUNW");
      stock = db.getStock("SUNW");
      stock.setPrice(79.25F);
			
      db.updateStockPrice(stock);
			
    } catch (Exception e) {
      System.out.println(e);
    }
		
    System.out.println();
    System.out.println();
		
    try {
			
      // testing updating a invalid stock price
      System.out.println("StockModelTest.main:  updating invalid stock JUNK");
      stock = new Stock("JUNK", 12.75F);
			
      db.updateStockPrice(stock);
			
    } catch (Exception e) {
      System.out.println("StockModelTest.main:  exception");
      System.out.println(e);
    }
  }
}


