package trader;

import trader.gui.*;
import java.io.*;

public class StockViewImpl implements StockView, Serializable {
	
  private StockGui gui;
	
  public StockViewImpl(StockModel model) {

    System.out.println("StockViewImpl.constructor: at start");

    try {
      Stock [] allStocks = model.getAllStocks();
      gui = new StockGui(allStocks);
      model.addChangeListener(this);
    } catch (Exception e) {
      System.out.println("Exception in StockViewImpl constructor");
      System.out.println(e);
    }		
    
    System.out.println("StockViewImpl.constructor: at end\n");
  }
	
  public void handleStockChange(Stock stock) throws BrokerException {
    System.out.println("StockViewImpl.handleStockChange");
    gui.updateStockDisplay(stock);
  }
}


