package trader.nw;

import trader.*;
import java.io.*;

public class HandleStockChangeCommand implements Serializable {
  
  private Stock stock;
  private Object result = null;
  private Exception excep = null;
 
  public HandleStockChangeCommand(Stock stock) {
    System.out.println("HandleStockChangeCommand.constructor:  instance created");
    this.stock = stock;
  }

  protected void execute(StockView view) {

    System.out.println("HandleStockChangeCommand.execute");

    try {
      
      view.handleStockChange(stock);
    } catch (Exception e) {
      System.out.println("Exception in HandleStockChangeCommand.execute");
      System.out.println(e);
    }
  }
  
  public Object getResult( )  throws  Exception {

    System.out.println("HandleStockChangeCommand.getResult");

    if (this.result != null){
      return this.result;
    }
    if (this.excep != null){
      throw this.excep;
    }
    return null;
  }

  public String toString() {
    return "HandleStockChangeCommand " + stock;

  }
}


