package trader.nw;

import java.io.*;
import java.net.*;
import trader.*;

public class StockModelCommandServer implements IoStrategy {
  
  private StockModel model;

  /** Creates new StockModelCommandServer */
  public StockModelCommandServer(StockModel model) {
    System.out.println("StockModelCommandServer.constructor:  instance created");
    this.model = model;
  }

  public void ioService(Socket socket) {

    System.out.println("StockModelCommandServer.ioService");

    InputStream is;
    ObjectInputStream ois;
    OutputStream os;
    ObjectOutputStream oos;
    try {
      is = socket.getInputStream();
      ois = new ObjectInputStream(is);
      os = socket.getOutputStream();
      oos = new ObjectOutputStream(os);
      while (true) {
        StockCommand cmd = (StockCommand) ois.readObject();
        System.out.println("\nStockModelCommandServer.ioService: read " + cmd);
        cmd.execute(model);
        oos.writeObject(cmd);
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
}

