package trader.nw;

import java.io.*;
import java.net.*;
import trader.*;

public class StockViewCommandServer implements IoStrategy{
  
  private StockView stockView;

  /** Creates new StockViewServer */
  public StockViewCommandServer(StockView stockView) {
    System.out.println("StockViewCommandServer.constructor:  instance created");
    this.stockView = stockView;
  }

  public void ioService(Socket socket) {

    System.out.println("StockViewCommandServer.ioService");

    InputStream is;
    ObjectInputStream ois;
    OutputStream os;
    ObjectOutputStream oos;
    try {

      is = socket.getInputStream();
      ois = new ObjectInputStream(is);
      os = socket.getOutputStream();
      oos = new ObjectOutputStream(os);
      while (true) {
        // cast to handleStockViewCommand
        HandleStockChangeCommand cmd = (HandleStockChangeCommand) ois.readObject();
        System.out.println("\nStockViewCommandServer.ioService: read " + cmd);
        cmd.execute(stockView);
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
}


