import java.util.*;
public class InfoController {
  // model data
  private InfoModel model;
  private InfoView view;
  private static int conNo=0;
  private int conId;


  public InfoController(InfoModel model, InfoView view) {
    conId = ++conNo;
    System.out.println("Controller " + conId +
      ": InfoController(model, view)");
    this.model = model;
    this.view = view;
    view.addUserGestureListener(this); //subscribe 
  }
  
  // user gesture handler methods
  public void processGetMessage() {
    System.out.println("Controller " + conId +
      ": processGetMessage() ");
    view.showDisplay("message");
  }  

  public void processGetWeather() {
    System.out.println("Controller " + conId +
      ": processGetWeather() ");
    view.showDisplay("weather");
  }  

  public void processMsgUpdate(String msg) {
    System.out.println("Controller " + conId +
      ": processMsgUpdate() ");
    model.setMessage(msg);
  }  

  public void processWthUpdate(String wth) {
    System.out.println("Controller " + conId +
      ": processWthUpdate() ");
    model.setWeather(wth);
  }  
}
