import java.util.*;
public class InfoModel {
  // model data
  private String message = "welcome to mvc";
  private String weather = "Sunny";
  // model listener management data structures
  private ArrayList listeners = new ArrayList(10);
  
  public InfoModel() {
    System.out.println("Model : InfoModel()");
  }

  // state query methods
  public String getMessage() {
    System.out.println("Model: getMessage() ");
    return message;
  }  
  public String getWeather() {
    System.out.println("Model: getWeather() ");
    return weather;
  }
  
  // state change methods
  public void setMessage(String msg) {
    System.out.println("Model: setMessage() ");
    message = msg;
    this.fireModelChangeEvent(message);
  }  
  public void setWeather(String wth) {
    System.out.println("Model: setWeather() ");
    weather = wth;
    this.fireModelChangeEvent(weather);
  }
  
  // listener registration method
  public void addModelChangeListener(InfoView view) {
    System.out.println("Model: addModelChangeListener(view) ");
    listeners.add(view);
  }  
  
  // private methods
  private void fireModelChangeEvent(Object o) {
    InfoView v;
    for (int i=0; i<listeners.size(); i++) {
      System.out.println("Model: fireModelChangeEvent() - for loop");
      v = (InfoView) listeners.get(i);
      v.processModelChange(o);
    }
  }      
}
