import java.sql.*;
public class JDBCExample {
  public static void main (String args[]) {
    try {
      // Load the Driver
      String driver ="com.pointbase.jdbc.jdbcUniversalDriver";
      Class.forName(driver);
      System.out.println("LOADED DRIVER  ---> " + driver);

      // Create the "url"
      // assume database server is running on the localhost
      String url = "jdbc:pointbase://localhost:9092/sample";
      // Connect to the database represented by url
      // with username PUBLIC and password PUBLIC
      Connection con =
      DriverManager.getConnection (url, "PUBLIC", "PUBLIC");
      System.out.println("CONNECTED TO   ---> "+ url);

      // Use the Connection to create a Statement object
      Statement stmt = con.createStatement ();

      // Execute query using Statement, receive the ResultSet
      String qry ="SELECT * FROM Customer ORDER BY cust_name";
      ResultSet rs = stmt.executeQuery(qry);
      System.out.println("EXECUTED QUERY ---> " + qry);

      // Print the results, row by row
      System.out.println("\nPROCESSING RESULTS:\n");
      while (rs.next()) {
        System.out.println("  SSN    : " + 
          rs.getString("ssn").trim());
        System.out.println("  NAME   : " + 
          rs.getString("cust_name").trim());
        System.out.println("  ADDRESS: " + 
          rs.getString("address").trim());
        System.out.println("");
      }
      rs.close();
      stmt.close();
      con.close();
    } catch (SQLException e) {
      e.printStackTrace();
    } catch (ClassNotFoundException e) {
      e.printStackTrace();
    }
  }
}
