package trader.db;
import java.util.*;
import java.sql.*;
import trader.*;
import java.rmi.RemoteException; 
import java.rmi.server.UnicastRemoteObject;

public class BrokerModelDbImpl extends 
  UnicastRemoteObject implements BrokerModel {
  ArrayList changeListeners = new ArrayList(10);
  Connection theConnection;
  
  public BrokerModelDbImpl() throws Exception,
    RemoteException {
    this("localhost");
  }

  public BrokerModelDbImpl(String hostName) throws Exception, 
    RemoteException {
    String  database = "sample";     // 
    String url;
    try {
      //** 1 Register a JDBC driver
      //**   The name of the pointbase driver class is
      //**   "com.pointbase.jdbc.jdbcUniversalDriver"
      Class.forName("com.pointbase.jdbc.jdbcUniversalDriver");
      //** 2 Construct the url string for JDBC access.
      //**   To be flexible use the local variables hostName
      //**   and database to construct the url string 
      url = "jdbc:pointbase://" + hostName +
        "/" + database;
      //** 3 Assign to theConnection attribute a connection
      //**   object obtained by invoking the getConnection
      //**   method on the DriverManager class
      theConnection = DriverManager.getConnection
        (url, "public", "public");
    } catch (Exception e) {
      e.printStackTrace();
      throw e;
    }
  }

  //Note - All other methods unchanged from non-rmi version
}
