import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

public class TableEventExample implements ListSelectionListener {
  String headers[] = {"Month", "Days"};
  String[][] tableArray;
  JTable table;
  JScrollPane pane;

  public TableEventExample() {
    tableArray = getTableArray();
    table = new JTable(tableArray, headers);
    pane = new JScrollPane(table);
  }

  String[][] getTableArray(){
    String[][] data = {
      {"January", "31"}, {"February", "28"}, {"March", "31"},
      {"April", "30"}, {"May", "31"}, {"June", "30"},
      {"July", "31"}, {"August", "31"}, {"September", "30"},
      {"October", "31"}, {"November", "30"}, {"December", "31"}};
    return data;
  } 

  public void addListSelectionListener(ListSelectionListener listener) {
    table.getSelectionModel().addListSelectionListener(listener);
  }

  public Object getSelected() {
    int row = table.getSelectedRow();
    if (row < 0) {
       return null;
    }
    else {
      return tableArray[row][0] + " has " + 
        tableArray[row][1] + " days";
    }
  }

  public void valueChanged(ListSelectionEvent e) {
    System.out.println("Selection event: " + getSelected());
  }

  public static void main(String[] args) {
    TableEventExample tab = new TableEventExample();
    JFrame jf = new JFrame("TableExample");
    Container con = jf.getContentPane();
    con.add(tab.pane, BorderLayout.CENTER);
    jf.setSize(200, 400);
    jf.validate();
    jf.setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
    jf.setVisible( true );
    tab.addListSelectionListener(tab);
  }
}
