import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

public class TableExample {
  String headers[] = {"Location", "Temperature", "Humidity"};
  String[][] tableArray; //table row data
  JTable table;
  JScrollPane pane;
  DefaultTableModel tableModel;

  public TableExample() {
    // create DefaultTableModel using col headers, number of rows
    tableModel = new DefaultTableModel(headers, 5); 
    table = new JTable(tableModel);  // create table
    pane = new JScrollPane(table);   // add table to scroll
  }
  

  private void updateTable (String[] locations){
    String newData[][] = new String[locations.length][3];
    // populate the newData array with new information
    for (int i=0; i<newData.length; i++) {
      newData[i][0] = locations[i];             // city name
      newData[i][1] = 50 * Math.random() + "c"; // temperature
      newData[i][2] = 100 * Math.random() + "%";// humidity
    }
    // display newData & headers on JTable
    tableModel.setDataVector(newData, headers); 
  } 


  public static void main(String[] args) throws Exception{
    String city[] = {"Denver", "New York", "Atlanta",
      "London", "Berlin", "Paris", "Sydney", "Singapore"};
    TableExample tab = new TableExample();
    JFrame jf = new JFrame("TableExample");
    Container con = jf.getContentPane();
    con.add(tab.pane, BorderLayout.CENTER);
    jf.setSize(200, 400);
    jf.validate();
    jf.setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );
    jf.setVisible( true );
    while(true) {
      tab.updateTable(city);
      Thread.sleep(5000); // 5 sec delay
    }
  }
}
