//import java.lang.reflect.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.sql.*;
import java.util.*;
import java.io.*;

public class SL285PBConsole{
  //gui
  JFrame f = new JFrame("SL285 PointBase Console");
  JPanel p = new JPanel();
  JScrollPane pSp;
  JTextArea histTa = new JTextArea(20,50);
  JScrollPane histSp = new JScrollPane(histTa);
  JLabel histLb = new JLabel("SQL Execution History", SwingConstants.CENTER);
  JTextField inputTf = new JTextField();
  JLabel inputLb = new JLabel("SQL Statement Entry", SwingConstants.CENTER);
  String [] varHeaders = {"   ", "     ", "     "};
  DefaultTableModel varTbModel;
  JTable varTb;
  JScrollPane varSp;
  JLabel varLb = new JLabel("SQL Result Set", SwingConstants.CENTER);
  
  // variable display
  String varTbData [][];
  int varCount = 0;
  String rowData[] = {" ", " ", " "};
  
  // JDBC related 
  Properties props;
  String driver;
  String url;
  String user;
  String pass;
  Connection con;
  Statement stmt;
  String qry ="SELECT * FROM Customer ORDER BY cust_name";
  ResultSet rs;
  int rowsUpdated;
  
  
  
  public SL285PBConsole() {
    Container conPane = f.getContentPane();
    GridBagConstraints gridBagConstraints1 = new java.awt.GridBagConstraints ();
    GridBagConstraints gridBagConstraints2 = new java.awt.GridBagConstraints ();
    p.setLayout(new GridBagLayout());

    //gridBagConstraints1.weightx =0.0;
    //gridBagConstraints1.weighty =0.0;
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    p.add(histLb, gridBagConstraints1);
    //gridBagConstraints2.weightx = 2.0;
    gridBagConstraints2.weighty = 2.0;
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
    p.add(histSp, gridBagConstraints2);
    histTa.setEditable(false);

    //gridBagConstraints1.weightx =0.0;
    //gridBagConstraints1.weighty =0.0;
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    p.add(inputLb, gridBagConstraints1);
    //gridBagConstraints1.weightx =0.0;
    //gridBagConstraints1.weighty =0.0;
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    p.add(inputTf, gridBagConstraints1);

    //gridBagConstraints1.weightx =0.0;
    //gridBagConstraints1.weighty =0.0;
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
    p.add(varLb, gridBagConstraints1);
    //varTb.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
    varTbModel = new DefaultTableModel(varHeaders, 10);
    varTb = new JTable(varTbModel);
    int rowHeight = varTb.getRowHeight();
    int rowWidth = 500; //varTb.getWidth();
    int rowCount = varTb.getRowCount();
    varTb.setPreferredScrollableViewportSize(new Dimension(rowWidth,(rowHeight*rowCount)));
    varSp = new JScrollPane(varTb);
    //gridBagConstraints1.weightx =0.0;
    //gridBagConstraints1.weighty =0.0;
    gridBagConstraints1.gridwidth = java.awt.GridBagConstraints.REMAINDER;
    gridBagConstraints1.fill = java.awt.GridBagConstraints.HORIZONTAL;
    p.add(varSp, gridBagConstraints1);
//    System.out.println("varTb rows = " + varTb.getRowCount());


    pSp = new JScrollPane(p);
    conPane.add(pSp);
    f.pack();
    f.setVisible(true);
    
    // register event listeners
    inputTf.addActionListener(new InputCodeListener(histTa, inputTf));
    //varTb.getSelectionModel().addListSelectionListener(new ListListener(varTb, varTbModel));
    establishConnection();
  }
  
  public void establishConnection() {
    try {
      // create a properties object
      props = new Properties();
      // load the properties object from the file
      props.load(new FileInputStream("SL285PBConsole.ini"));
      // set the value of driver to the jdbcDriver property
      driver = props.getProperty("jdbcDriver");
      Class.forName(driver);
      System.out.println("LOADED DRIVER  ---> " + driver);

      // set the value of url to the jdbcUrl property
      url = props.getProperty("jdbcUrl");
      // set the value of url to the jdbcUser property
      user = props.getProperty("jdbcUser");
      // set the value of url to the jdbcPassword property
      pass = props.getProperty("jdbcPassword");
      // Connect to the database represented by url 
      // with username user and password pass
      con =
      DriverManager.getConnection (url, user, pass);
      System.out.println("CONNECTED TO   ---> "+ url);
      // Use the Connection to create a Statement object
      stmt = con.createStatement ();
      // Execute query using Statement, receive the ResultSet
      String qry ="SELECT * FROM Customer ORDER BY cust_name";
      executeQuery(qry);
      System.out.println("EXECUTED QUERY ---> " + qry);
      displayRS();
    } catch(Exception e){
      e.printStackTrace();
    }
  }
  
  public void executeQuery(String request) throws Exception {
    rs = stmt.executeQuery(request);
  }
  
  public void executeUpdate(String request) throws Exception {
    rowsUpdated = stmt.executeUpdate(request);
  }
  
  public void displayRS() throws Exception {
    ResultSetMetaData rsmd = rs.getMetaData();
    ArrayList rowDataList = new ArrayList(10);
    int colCnt = rsmd.getColumnCount();
    varHeaders = new String[colCnt];
    rowData = new String[colCnt];
    for (int i=0; i<colCnt; i++) {
      varHeaders[i] = rsmd.getColumnLabel(i+1);
    }
    while (rs.next()) {
      rowData = new String[colCnt];
      for (int i=0; i<colCnt; i++) {
        rowData[i] = rs.getString(i+1);
        System.out.print(rowData[i] + "  ");
      }
      System.out.println(" ");
      rowDataList.add(rowData);
    }
    varTbData = new String[rowDataList.size()][];
    for (int i=0; i<rowDataList.size(); i++) {
      varTbData[i] = (String[])rowDataList.get(i);
      System.out.println(i + "  " + varTbData[i][0]);
    }
    varTbModel.setDataVector(varTbData, varHeaders);
    
  }   
  public void addVariable() {
  }
  
  
  public void refreshVarTb(){
    String value;
  }
  
  class InputCodeListener implements ActionListener{
    private JTextArea target;
    private JTextField source;
    
    public InputCodeListener(JTextArea target, JTextField source){
      this.target = target;
      this.source = source;
    }
    
    public void actionPerformed(ActionEvent e){
      try {
        String s = source.getText();
        source.setText("");
        target.append(s + "\n");
        s = s.trim();
        String lower = s.toLowerCase();
        if (s.charAt(s.length()-1) == ';') {
          s = s.substring(0, s.length()-1);
        }
        if (lower.indexOf("select") != -1) {
          executeQuery(s);
          displayRS();
        }
        else {
          executeUpdate(s);
          target.append(rowsUpdated + " rows updated\n");
        }
      } catch(Exception ex){
        target.append(ex + "/n");
        ex.printStackTrace();
      }
    }
  }

      
    

  public static void main(String args[]) {
    System.out.println("SL285PBConsole copyright Sun Microsystems Inc 2001");
    SL285PBConsole app = new SL285PBConsole();
  }
}
