package trader.rmi;
import trader.*;
import trader.db.*;
import java.rmi.Naming; 
import java.rmi.RMISecurityManager;
public class BrokerRMIServer {
  public static void main(String args[]){
    String dbHost = "localhost";
    try {
      if (args.length > 0) {
        dbHost = args[0];
      }
      BrokerModel brokerModel = new BrokerModelDbImpl(dbHost);
      // Bind this object instance to the name "TheBroker" 
      Naming.rebind("//localhost/TheBroker", brokerModel); 
      System.out.println("BrokerServer bound in registry"); 
    } catch (Exception e) { 
      System.out.println("BrokerRMIServer err: " + e.getMessage()); 
    } 
  }
}
