package trader.nw;
import trader.*;
import java.io.*;

public abstract class Command implements Serializable {
  protected Object    result = null;
  protected Exception excep = null;

  protected abstract void execute(BrokerModel broker);
  /**
    * @exception  DuplicateException  
    *     if another record has same primary key
    * @exception  RecordNotFoundException 
    *     if no record is found in the table
    */

  public Object getResult( )  throws  Exception{
    if (this.result != null){
      return this.result;
    }
    if (this.excep != null){
      throw this.excep;
    }
    return null;
  }
}
