package trader.nw;
import java.io.*;
import java.net.*;
import trader.*;
import trader.db.*;
/** AddCommand and DeleteCommand UnitTest.
    Compile from classes directory
    javac -d . ../src/trader/nw/CommandTester.java
    java trader.nw.CommandTester
*/
    
class CommandTester {

  public static void main(String args[]){
    String dbHost = "localhost";
    Customer cust = new Customer("333_33_3333",
      "Dough Nut", "Bakery Lane");
    Command addCmd = new AddCustomerCommand(cust);
    Command delCmd = new DeleteCustomerCommand(cust);
    //Command getCmd = new GetCustomerCommand("333_33_3333");
    System.out.println("CommandTester - AddCommand & " +
      "DeleteCommand Unit Test");
    try {
      if (args.length > 0) {
        dbHost = args[0];
      }
      BrokerModel brokerModel = new BrokerModelDbImpl(dbHost);
      System.out.println("Adding Customer " + cust);
      addCmd.execute(brokerModel);
      Thread.sleep(5000);
      System.out.println("Deleting Customer " + cust);
      delCmd.execute(brokerModel);
    } catch(Exception e) {
      e.printStackTrace();
    }
  }
}
