package trader;
import java.rmi.Remote;
import java.rmi.RemoteException;
public interface BrokerView extends Remote{
//user gesture listener registration methods
  /* ---------------------------------------------------------------
   * adds requester to the list of objects to be notified of user 
   * gestures entered through a user interface such as a GUI.
   * User gestures for the customer segment are add, delete, update
   * get and getAll customers. There are similar user gestures for 
   * portfolio and stock segments
   */
  void addUserGestureListener(BrokerController b)
    throws BrokerException, RemoteException;
    
//display selection request service methods  
  /* ---------------------------------------------------------------
   * shows the display page specified by the broker controller
   */
  void showDisplay(Object display) throws BrokerException,
    RemoteException;
  
// iteration 1 Customer segment broker view methods
  /* ---------------------------------------------------------------
   * callback method to handle customer state change notification
   * from the broker model
   */
  void handleCustomerChange(Customer cust)
    throws BrokerException, RemoteException;


// Portfolio segment - TBD in future iteration
// Add method to handle portfolio change notification from the 
// broker model

// Stock segment - TBD in future iteration
// Add method to handle stock change notification from broker model
}
