package trader.rmi;
import trader.*;
import trader.gui.*;
import java.rmi.Naming; 
import java.rmi.RemoteException; 
public class BrokerRMIClient{
  BrokerModel model;
  BrokerView view;
  BrokerController con;

  public static void main(String args[]) {
    String rmiRegistryHost = "localhost";
    try {
      if (args.length > 0) {
        rmiRegistryHost = args[0];
      }
      BrokerRMIClient client = new BrokerRMIClient();
      client.model = (BrokerModel) 
        Naming.lookup("//" + rmiRegistryHost + "/TheBroker"); 
      client.view = new BrokerViewImpl(client.model);
      client.con = 
        new BrokerControllerImpl(client.model, client.view);
    } catch (Exception e) { 
      System.out.println("BrokerRMIClient exception: " + e); 
    }
  }
}
